(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***         Portions Copyright (c) 2002 by Eugen Honeker (see below)       ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/  e.honeker@vclfree.de ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                       Privet iz Germanij                               ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeata Magica, Kurtzweyl, Manowar,    ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- & Eugen Honeker ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

function SetWindowTopMost(hWnd: HWND; bTopMost: boolean): boolean;
(*
  Functionality:
    Sets the given window to stay always on top.
    [GENERIC]
*)
begin
  result := SetWindowPos(hWnd, HWND_NOTOPMOST + WORD(bTopMost), 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or
    SWP_NOACTIVATE);
end;

function IsTopMost(hWnd: HWND): boolean;
(*
  Functionality:
    Checks wether the window is set to stay on top.
    [GENERIC]
*)
begin
  result := BOOL(GetWindowLong(hWnd, GWL_EXSTYLE) and WS_EX_TOPMOST);
end;

procedure SelectWindow(hwnd: HWND);
(*
  Functionality:
    This will provide the "selected" effect on the targeted windows.
    [GENERIC]

  Featured by Eugen - all credits go to him!!!

  Just modified to show a different graphical behavior
  Plus some addidional safety due to conditional jumps
*)
var
  dc: HDC;
  rc: TRect;
  hOldPen, hOldBrush: HBrush;
begin
  if GetWindowRect(hwnd, rc) then
  begin
    dc := GetWindowDC(hwnd);
    if dc <> 0 then
    try
{$IFDEF AssasSelectionStyle}
      SetROP2(dc, R2_NOTXORPEN);
      hOldBrush := SelectObject(dc, GetStockObject(NULL_BRUSH));
      hOldPen := SelectObject(dc, CreatePen(PS_SOLID, 3, $00));
      with rc do
        Rectangle(dc, 1, 1, Right - Left - 1, Bottom - Top - 1);
      SelectObject(dc, hOldBrush);
      DeleteObject(SelectObject(dc, hOldPen));
{$ELSE AssasSelectionStyle}
      SetROP2(dc, R2_NOTXORPEN);
      hOldBrush := SelectObject(dc, GetStockObject(NULL_BRUSH));
      hOldPen := SelectObject(dc, CreatePen(PS_DOT, 1, $00));
      with rc do
        Rectangle(dc, 1, 1, Right - Left, Bottom - Top);
      SelectObject(dc, hOldBrush);
      DeleteObject(SelectObject(dc, hOldPen));
{$ENDIF AssasSelectionStyle}
    finally
      ReleaseDC(hwnd, dc);
    end;
  end;
end;

procedure MyUpdateWindow(hwnd: HWND);
(*
  Functionality:
    This will update the window by sending/posting a WM_PAINT message to it.
    [GENERIC]

  Although I (Assarbad) wrote it, it fits into the context of this include.
*)
var
  TID: THandle;
begin
  TID := GetWindowThreadProcessId(hwnd, nil);
  if GetCurrentThreadID = TID then
    SendMessage(hwnd, WM_PAINT, 0, 0)
  else
    PostThreadMessage(TID, WM_PAINT, 0, 0);
end;

{$IFDEF AssasRedrawScheme}

procedure UnSelectWindow(hwnd: HWND);
(*
  Functionality:
    This will unselect and repaint the last targeted window.
    [SPECIFIC]
*)
begin
  {
  // From 2.50pre0 --->
    SelectWindow(hwnd);
    ReDrawWindow(hwnd, nil, 0, RDW_ERASE or RDW_INVALIDATE);
  (*
    It is an obviously better approach to POST the message to the thread that owns
    the respective window, instead of just SENDing it indirectly by calling
    ReDrawWindow() which calls SendMessage() with WM_PAINT on behalf of the
    calling thread. Note, that SendMessage() as far as I observed, is only guaran-
    teed to work inside the calling thread.
  *)
  }
  SelectWindow(hwnd);
  MyUpdateWindow(hwnd);
end;
{$ENDIF AssasRedrawScheme}

{DEFINE RWFPCHOICE}
(*
  Note, that the undefined state should be considered as default!
  This will resemble the behavior of ChildWindowFromPoint which indeed returns
  invisible child windows - which Eugens func did not ;)
  Hence defining it will restore the behavior considered by Eugen.
  However Eugen did not use "swinvis" as an external parameter, although it was
  set to true by default.
*)

function RealWindowFromPoint(pt: TPoint{$IFDEF RWFPCHOICE}; swinvis: boolean = true{$ENDIF}): HWND;
(*
  Functionality:
    This will get a windows handle from the position of the mouse, even if it is
    for example inside the area occupied by a groupbox.
    [GENERIC] It may be used as a substitute to "ChildWindowFromPoint" which
    however doesn't work as well as this one ;)

  Featured by Eugen, all credits go to him ...

  Corrected version (by Eugen) - should work on 9x now ;)
  I changed a few things more to have a more consistent behavior
*)
type
  PCHILDS_ENUM = ^CHILDS_ENUM;
  CHILDS_ENUM = record
    nDiff: integer;
    hWndFound: HWND;
    pt: TPoint;
{$IFDEF RWFPCHOICE}
    showinvis: boolean;
{$ENDIF RWFPCHOICE}
  end;

var
  ce: CHILDS_ENUM;

  function EnumProc(hwndChild: HWND; lParam: LPARAM): Boolean; stdcall;
(*
  Functionality:
    This is the core of RealWindowFromPoint. It enumerates child windows of the
    window given by handle.
    [SPECIFIC] only useful in the context of this function.
*)
  var
    rc: TRECT;
  begin
    GetWindowRect(hwndChild, rc);

    with PCHILDS_ENUM(lParam)^, rc do
{$IFDEF RWFPCHOICE}
      case showinvis of
        true:
          if (pt.x >= Left) and (pt.x < Right) and (pt.y >= Top) and (pt.y < Bottom) and
            (nDiff > (Right - Left) + (Bottom - Top)) then
          begin
            hWndFound := hwndChild;
            nDiff := (Right - Left) + (Bottom - Top);
          end;
      else
        if (pt.x >= Left) and (pt.x < Right) and (pt.y >= Top) and (pt.y < Bottom) and
          (nDiff > (Right - Left) + (Bottom - Top)) and IsWindowVisible(hwndChild) then
        begin
          hWndFound := hwndChild;
          nDiff := (Right - Left) + (Bottom - Top);
        end;
      end;
{$ELSE RWFPCHOICE}
      if (pt.x >= Left) and (pt.x < Right) and (pt.y >= Top) and (pt.y < Bottom) and
        (nDiff > (Right - Left) + (Bottom - Top)) then
      begin
        hWndFound := hwndChild;
        nDiff := (Right - Left) + (Bottom - Top);
      end;
{$ENDIF RWFPCHOICE}
    Result := True;
  end;

begin
  ce.nDiff := MAXLONG;
  ce.hWndFound := WindowFromPoint(pt);
  ce.pt.x := pt.x; //scheiss-w9x
  ce.pt.y := pt.y; //scheiss-w9x
{$IFDEF RWFPCHOICE}
  ce.showinvis := swinvis;
{$ENDIF RWFPCHOICE}
  if (ce.hWndFound <> 0) then
  begin
      // Windows 9x does not like NULL for a handle handed over to EnumChildWindows()
      // The NT platform treats this just like EnumWindows()
    if (GetWindowLong(ce.hWndFound, GWL_STYLE) and WS_CHILD <> 0) then
      ce.hwndFound := GetParent(ce.hwndFound);
    EnumChildWindows(ce.hWndFound, @EnumProc, Integer(@ce));
  end;
  Result := ce.hwndFound;
end;

