(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros etc pp.                                                        ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

function MyGetSaveFileName(appwnd: hwnd): string;
(*
  Functionality:
    Opens a save-dialog and asks for the name of a file to save a bitmap file.
    It returns a string with the filename or an empty string.
    [GENERIC]
*)
var
  ofn: TOpenFileName;
  ofn_buffer: array[0..MAX_PATH - 1] of char;
begin
  result := '';
  ZeroMemory(@ofn, sizeof(ofn));
  ZeroMemory(@ofn_buffer[0], sizeof(ofn_buffer));
  ofn.lStructSize := sizeof(ofn);
  ofn.hWndOwner := appwnd;
  ofn.hInstance := hInstance;
  ofn.lpstrInitialDir := nil;
  ofn.lpstrFilter := @filterstring[1];
  ofn.lpstrDefExt := 'bmp';
  ofn.nMaxFile := sizeof(ofn_buffer);
  ofn.lpstrFile := ofn_buffer;
  ofn.Flags := OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
  if not GetSaveFileName(ofn) then
  begin
    ZeroMemory(@ofn, sizeof(ofn));
    ZeroMemory(@ofn_buffer[0], sizeof(ofn_buffer));
  end;
  SetString(result, PChar(@ofn_buffer), lstrlen(@ofn_buffer));
end;

procedure ProcessMessages(hwnd: HWND);
(*
  Functionality:
    Calls PeekMessage() to remove and process the pending messages.
    This is done for both, windows and dialogs!
    [GENERIC]
*)
var
  msg: TMsg;
begin
  while PeekMessage(msg, 0, 0, 0, PM_REMOVE) do
    if not IsDialogMessage(hwnd, msg) then
    begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
end;

function WndCapture(appwnd, hwnd: HWND): Boolean;
(*
  Functionality:
    Calls the following three important functions:
    - MyGetSaveFileName()
    - ProcessMessages()
    - ScreenShotThis() (from ScreenShot.pas unit in .\ScreenShotUnit)
    If the window to snapshot is the application's windows or a child of it, the
    application will not hide. Else the application window is hidden to get a
    snapshot of the windows with which it might overlap ;)
    [GENERIC]
*)
var
  fname: string;
  DIB: THandle;
begin
  result := FALSE;
// Set the window to capture to foreground
  SetForegroundWindow(hwnd);
// Hide window if it is not client of or application window itself
  if (hwnd <> appwnd) and (not IsChild(appwnd, hwnd)) then
    ShowWindow(appwnd, SW_HIDE);
// Process Message to apply the changes, e.g. hiding the application window
  ProcessMessages(appwnd);
// Make screenshot and compress using RLE for 4 and 8bit
  DIB := ScreenShotThisInit(hwnd, false);
// Show app window anyway (even if not we have hidden it)
  if not IsWindowVisible(appwnd) then
  begin
    ShowWindow(appwnd, SW_SHOW);
    SetForeGroundWindow(appwnd);
  end;
  ProcessMessages(appwnd);
  if DIB <> 0 then
  begin
    fname := MyGetSaveFileName(hwnd);
    if fname <> '' then
      result := ScreenShotThisFinit(DIB, fname)
    else
    begin
      DestroyDIB(DIB); // Free the DIB
// If the user gave no name, he probably cancelled the selection!
// Hence exit here.
      exit;
    end;
    if not result then
      MessageBox(hwnd, @capfailed2[1], nil, 0);
  end
  else
    MessageBox(hwnd, @capfailed[1], nil, 0);
end;

